<?php
/*
 * JSON proxy for Summon service, originally from Virginia Tech.
 * Edited by Feng Yikang, National University of Singapore 7 July 2015.
 */
 
// to allow use only from NUS LibGuides

$referralURL = "libguides.nus.edu.sg";
 
if(!isset($_SERVER['HTTP_REFERER'])){
    die('only usable by NUS');
}
else if (parse_url($_SERVER['HTTP_REFERER'], PHP_URL_HOST)!==$referralURL) {
    die('only usable by NUS');
}

require_once("key.php");
require_once("SerialsSolutions_Summon_PEAR.php");

// copy all parameters that start with s.
$query_arr = array();

// PhP replaces . with _ in _REQUEST keys
// http://www.php.net/manual/en/language.variables.external.php
// see http://api.summon.serialssolutions.com/help/api/search/parameters/role
$query_arr['s.role'] = 'authenticated';

// fallback - simply 'q'
if (isset($_REQUEST['q'])) {
    $query_arr['s.q'] = $_REQUEST['q'];
}

if (!isset($query_arr['s.q'])) {
    $query_arr['s.q'] = '';
}

foreach ($_REQUEST as $key => $value) {
    // skip jQuery arguments
    if ($key == "callback" || $key == "_") {
        continue;
    }

    // replace t.AuthorCombined=x with AuthorCombined:(x)
    // for all t.*
    if (strpos($key, "t_") === 0) {
        $query_arr['s.q'] = $query_arr['s.q'] . " " . substr($key, 2) . ":(" . $value . ")";
        continue;
    }

    // replace the first _ with a .?  
    $count = 1;
    $key2 = str_replace('_', '.', $key, $count);
    $query_arr[$key2] = $value;
}

$summon = new SerialsSolutions_Summon_PEAR($apiId, $apiKey);
// $summon->debug = true;

// Third  argument "true" specifies the results to be returned in raw JSON format
$result = $summon->query(new SerialsSolutions_Summon_Query($query_arr['s.q'], $query_arr), false, true);

$reply = $result;
if (isset($_REQUEST['callback'])) {
    $reply = $_REQUEST['callback'] . "(" . $reply . ")\n";
    header("Content-Type: text/javascript");
} else {
    header("Content-Type: application/json");
}

echo $reply;

?>